var urlBaseApi = "https://gerarcertificado.com.br/API/";
var b64ModeloNovo = "";
var b64ModeloVerso = "";

var gerando = false;
var gerandoLote = false;
var assinaturaAtiva = false;
var saldoAssinaturaUsuario = 0;
var saldoUsuario = 0;

var idModeloSelecionado = 0;
var alunos = new Array();
var qtdAlunos = 0;
var programas = new Array();
var dadosCursoValidados = false;
var tcert = '';

var palestraTitulo = "";
var palestraProfessor = "";
var palestraData = "";
var palestraLocal = "";
var palestraCargaHoraria = "";
var dadosCustomizadosPalestra = new Array();

//modal para edição de modelo
var idModal = "myModal";

//dados reais edição modelo
var pixelEm1Cm = 56;
var wCertificadoReal = 0;
var hCertificadoReal = 0;
var mSuperiorRealCm = 0;
var mEsquerdaRealCm = 0;
var mDireitaRealCm = 0;

//dados simulados
var mSuperiorRealPx = (mSuperiorRealCm/10)*pixelEm1Cm;
var mEsquerdaRealPx = (mEsquerdaRealCm/10)*pixelEm1Cm;
var mDireitaRealPx = (mDireitaRealCm/10)*pixelEm1Cm;
var wCertificadoSimulado = 0;
var hCertificadoSimulado = 0;
var mSuperiorSimulado = 0;
var mInferiorSimulado = 0;
var mEsquerdaSimulado = 0;
var mDireitaSimulado = 0;
var wTextoSimulado = 0;
var hTextoSimulado = 0;

function initAplicacao(){
    jQuery('.page-login').removeClass('open');
    jQuery('.aplicacao').removeClass('close');
    getSaldoUsuario();
    getModelos();	
}

function login(email, senha){
    var token = btoa(email + ":" + senha);
    jQuery.ajax({
        type: "POST",
        url: urlBaseApi + "auth/V1/",
        dataType: 'json',
        beforeSend: function (xhr) {
            xhr.setRequestHeader("Authorization", "Basic " + token);
        }
    }).success(function(data) {
        localStorage.setItem('pgc-token', token);
        localStorage.setItem('pgc-verso', data[0].verso);
		localStorage.setItem('pgc-qr_code', data[0].qr_code);
		localStorage.setItem('pgc-url_validacao', data[0].url_validacao);
		localStorage.setItem('pgc-variaveis', data[0].variaveis);
        initAplicacao();
    }).fail(function() {
        alert('Dados de login não conferem');
    });
}

function logout(){
	localStorage.removeItem('pgc-token');
	localStorage.removeItem('pgc-verso');
	localStorage.removeItem('pgc-qr_code');
	localStorage.removeItem('pgc-url_validacao');
	localStorage.removeItem('pgc-variaveis');
	solicitaLogin();
}

function solicitaLogin(){
    jQuery('.page-login').addClass('open');
    jQuery('.aplicacao').addClass('close');
}

function getToken(){
    if(localStorage.getItem('pgc-token') != undefined && localStorage.getItem('pgc-verso') != undefined && localStorage.getItem('pgc-qr_code') != undefined && localStorage.getItem('pgc-url_validacao') != undefined && localStorage.getItem('pgc-variaveis') != undefined){
        return localStorage.getItem('pgc-token');
    } else {
        solicitaLogin();
        return false;
    }    
}

function getSaldoUsuario(){
    jQuery('#sua-conta .saldo').html('Consultando...');
	jQuery('#sua-conta .saldo-assinatura').html('Consultando...');
    if(getToken()) {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "credits/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            }
        }).done(function(data) {
            saldoUsuario = data[0].credits;
            jQuery('#sua-conta .saldo').html(saldoUsuario);
			var idModalOcultar = "myModal-model-cert-avancado";
			if(data[0].monthlyCredits > 0){
				assinaturaAtiva = true;
				if(localStorage.getItem('pgc-verso') != undefined && localStorage.getItem('pgc-verso') != '0'){
					idModalOcultar = "myModal";
					idModal = "myModal-avancado";
				} else {
					jQuery('#' + idModal + ' .col.editor-simples').remove();
				}
				jQuery('#sua-conta #dados-sem-assinatura').hide();
				jQuery('#sua-conta .saldo-assinatura').html(data[0].remainingCredits + ' de ' + data[0].monthlyCredits);
				saldoAssinaturaUsuario = data[0].remainingCredits;
				jQuery('.aplicacao table tr.alerta.franquia span.emissoes-gratis').html(data[0].monthlyCredits);
				jQuery('.aplicacao table tr.alerta.franquia span.emissoes-restantes').html(data[0].remainingCredits);
				var variaveisUsuario = getVariaveisUsuario();
				jQuery.each(variaveisUsuario, function(index, arrVar){
					if(arrVar['tipo'] == "personalizada" && arrVar['categoria'] == "aluno"){
						var campoPersonalizado = '<input type="text" class="form-control" name="' + arrVar['var'] +'" placeholder="' + arrVar['label'] +' (Opcional)" onblur="atualizarAlunosManualmente();">';
						jQuery('#form-manual-aluno #dados .dados .campos').append(campoPersonalizado);
					}
					if(arrVar['tipo'] == "personalizada" && arrVar['categoria'] == "curso"){
						var campoPersonalizado = '<div class="form-group"><label for="' + arrVar['label'] +'">' + arrVar['label'] +' (opcional)</label><input type="text" class="form-control" id="' + arrVar['label'] +'" name="' + arrVar['var'] +'" onblur="verificaDadosCurso()"></div>';
						jQuery('#form-dados-curso').append(campoPersonalizado);
					}
				});
			} else {
				jQuery('#sua-conta #dados-com-assinatura').hide();
				jQuery('.aplicacao #rodar-algoritmo table tr.alerta.franquia').remove();
				localStorage.setItem('pgc-variaveis', "");
			}
			jQuery('#' + idModalOcultar).remove();
			if(localStorage.getItem('pgc-verso') == 1){
				jQuery('#sua-conta #btn-verso').hide();
			}
			if(localStorage.getItem('pgc-qr_code') == 0){
				jQuery('#sua-conta #btn-qr-code').hide();
			}
			if(localStorage.getItem('pgc-url_validacao') != "null"){
				jQuery('#sua-conta #btn-validacao-externa').hide();
			}
        }).fail(function() {
            solicitaLogin();
        });
    } else {
        solicitaLogin();
    }
}

function getVariaveisUsuario(){
	var arrVars = new Array();
	if(localStorage.getItem('pgc-variaveis') != undefined && localStorage.getItem('pgc-variaveis') != ""){
		arrVars = JSON.parse(localStorage.getItem('pgc-variaveis'));
	}
	return arrVars;
}

function getModelos(funcaoCallback = null){
    jQuery('#modelos .certificados').empty();
    jQuery('#modelos_usuario .certificados').empty();
    if(getToken()) {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/getAll/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            }
        }).done(function(data) {
            jQuery.each(data[0].models.publics, function(index, arrCertificado){
                var elem =  '<div id="certificado-' + arrCertificado.id + '" class="certificado" onclick="selecionaCertificado(' + arrCertificado.id + ')">';
                    elem += '<img src="' + arrCertificado.thumb + '"/>';
                    elem += '<div class="nome">';
                    elem += '<span class="dashicons dashicons-yes"></span> ' + arrCertificado.nome;
                    elem += '</div>';
                    elem += '</div>';
                jQuery(elem).appendTo('#modelos .certificados');    
            });
            jQuery.each(data[0].models.privates, function(index, arrCertificado){
                var elem =  '<div id="certificado-' + arrCertificado.id + '" class="certificado" onclick="selecionaCertificado(' + arrCertificado.id + ')">';
                    elem += '<img src="' + arrCertificado.thumb + '"/>';
                    elem += '<a class="btn btn-xs btn-danger excluir" title="Excluir este modelo" onclick="excluirModelo(' + arrCertificado.id + ')">';
                    elem += '<span class="dashicons dashicons-trash"></span>';
                    elem += '</a>';
                    elem += '<div class="nome">';
                    elem += '<span class="dashicons dashicons-yes"></span> ' + arrCertificado.nome + '<br/>';
                    elem += '<a class="editar" onclick="editarModelo(' + arrCertificado.id + ')">';
                    elem += '<span class="dashicons dashicons-edit" aria-hidden="true"></span> Editar preferências';
                    elem += '</a>';
                    elem += '</div>';
                    elem += '</div>';
                jQuery(elem).appendTo('#modelos_usuario .certificados');    
            });
            if(funcaoCallback !== null){
                eval(funcaoCallback);
            }
        }).fail(function() {
            solicitaLogin();
        });
    }
}

jQuery('#input-form-modelo').on('change', function(){
    const file = jQuery(this)[0].files[0];
    const fileReader = new FileReader();
    fileReader.onloadend = function(){        
        //se tiver mais de 250kb
        if(file.size > 250000){
            alert('arquivo muito grande')
        }
        //se não for jpg
        if(file.type != "image/jpeg") {
            alert('arquivo precisa estar no formato JPG')
        }
        //ativa envio ou não
        if(file.size > 500000 || file.type != "image/jpeg"){
            jQuery('#form-novo-modelo button[type="submit"]').attr('disabled','disabled');
            b64ModeloNovo = "";
        } else {
            jQuery('#form-novo-modelo button[type="submit"]').removeAttr('disabled');
            b64ModeloNovo = fileReader.result;
        }            
    }
    fileReader.readAsDataURL(file);
});

function informarCadastroModelo(){
    jQuery('.aplicacao .abas #modelos_usuario #btn-cadastro-modelo').hide();
    jQuery('.aplicacao .abas #modelos_usuario #form-novo-modelo').show();
}

function criaModeloNovo(){
    if(getToken() && b64ModeloNovo != "") {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/create/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {b64: b64ModeloNovo}            
        }).done(function(data) {
            getModelos('editarModelo(' + data[0] + ')');
            jQuery('.aplicacao .abas #modelos_usuario #btn-cadastro-modelo').show();
            jQuery('.aplicacao .abas #modelos_usuario #form-novo-modelo').hide();
        }).fail(function() {
            solicitaLogin();
        });
    }
}

function editarModelo(idCertificado){
    jQuery('#' + idModal).modal('show');
    if(getToken() && idCertificado != "") {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/getById/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {idModel: idCertificado}            
        }).done(function(data) {

			var variaveisUsuario = getVariaveisUsuario();
            var textOriginal = data[0].text;
            var text = textOriginal;
            var textTextarea = textOriginal.replace(/<br\/>/g, '\r\n');

            if(textOriginal != "") {            
                text = text.replace(/(?:\ r\n|\r|\n)/g, '<br/>');
                text = text.replace(/\[NOME_PARTICIPANTE_ALUNO\]/g, '<span class="grande1">Nome do aluno</span>');
                text = text.replace(/\[NOME_PALESTRA_CURSO\]/g, '<span class="grande2">título da palestra ou curso</span>');
                text = text.replace(/\[NOME_PALESTRANTE_PROFESSOR\]/g, '<span class="grande2">Nome do instrutor</span>');
                text = text.replace(/\[DATA_PALESTRA_CURSO\]/g, '<span>Agosto/2020</span>');
                text = text.replace(/\[LOCAL_REALIZACAO\]/g, '<span>São José/SC</span>');
                text = text.replace(/\[CARGA_HORARIA\]/g, '<span>300 horas</span>');
				text = text.replace(/\[DATA_EMISSAO_CERTIFICADO\]/g, '<span>14/08/2020</span>');
				jQuery.each(variaveisUsuario, function(index, arrVar){
					if(arrVar['tipo'] == "personalizada"){
						var str = "\\" + arrVar['var'].replace("\]", "\\]");
						var regex = new RegExp(str, "g");
						text = text.replace(regex, '<span>' + arrVar['label'] + '</span>');
					}
				});
                textTextarea = textOriginal.replace(/<br\/>/g, '\r\n');
            } else {
                textOriginal = 'Certificamos que<br/>[NOME_PARTICIPANTE_ALUNO]<br/><br/>participou da palestra/curso<br/>[NOME_PALESTRA_CURSO]<br/><br/>ministrada por<br/>[NOME_PALESTRANTE_PROFESSOR]<br/><br/>realizado(a) [DATA_PALESTRA_CURSO], [LOCAL_REALIZACAO]<br/><br/>Com carga horária de [CARGA_HORARIA]';
                text  = "<p>Certificamos que</p><span class=\"grande1\">Nome do aluno</span><br/><br/><p>participou da palestra/curso</p><span class=\"grande2\">título da palestra ou curso</span><br/><br/><p>ministrada por</p><span class=\"grande2\">Nome do instrutor</span><br/><br/><p>realizada em Agosto/2020, São José/SC.</p><br/><p>Com carga horária de 300 horas</p>";
                textTextarea = textOriginal.replace(/<br\/>/g, '\r\n');
            }
			
			var textOriginalVerso = data[0].verseText;
            var textVerso = textOriginalVerso;
            var textVersoTextarea = textOriginalVerso.replace(/<br\/>/g, '\r\n');			

            if(textOriginalVerso != "") {            
                textVerso = textVerso.replace(/(?:\ r\n|\r|\n)/g, '<br/>');
                textVerso = textVerso.replace(/\[NOME_PARTICIPANTE_ALUNO\]/g, '<span>Nome do aluno</span>');
                textVerso = textVerso.replace(/\[NOME_PALESTRA_CURSO\]/g, '<span>título da palestra ou curso</span>');
                textVerso = textVerso.replace(/\[NOME_PALESTRANTE_PROFESSOR\]/g, '<span>Nome do instrutor</span>');
                textVerso = textVerso.replace(/\[DATA_PALESTRA_CURSO\]/g, '<span>Agosto/2020</span>');
                textVerso = textVerso.replace(/\[LOCAL_REALIZACAO\]/g, '<span>São José/SC</span>');
                textVerso = textVerso.replace(/\[CARGA_HORARIA\]/g, '<span>300 horas</span>');
				textVerso = textVerso.replace(/\[DATA_EMISSAO_CERTIFICADO\]/g, '<span>14/08/2020</span>');
				jQuery.each(variaveisUsuario, function(index, arrVar){
					if(arrVar['tipo'] == "personalizada"){
						var str = "\\" + arrVar['var'].replace("\]", "\\]");
						var regex = new RegExp(str, "g");
						textVerso = textVerso.replace(regex, '<span>' + arrVar['label'] + '</span>');
					}
				});
                textVersoTextarea = textOriginalVerso.replace(/<br\/>/g, '\r\n');
            } else {
                textOriginalVerso = 'Certificado concedido a:<br/>[NOME_PARTICIPANTE_ALUNO]<br/>Palestra/curso:<br/>[NOME_PALESTRA_CURSO]<br/>Carga horária:<br/>[CARGA_HORARIA]';
                textVerso  = "<p>Certificado concedido a:<br/>Nome do aluno<br/>Palestra/curso:<br/>título da palestra ou curso<br/>Carga horária:<br/>300 horas</p>";
                textVersoTextarea = textOriginalVerso.replace(/<br\/>/g, '\r\n');
            }

            jQuery('#' + idModal + ' .modal-title').html('Editar preferências do modelo');
            jQuery('#' + idModal + ' .modal-footer button#salvar').attr('onclick','salvarModelo(' + idCertificado + ')');
            jQuery('#' + idModal + ' .modelo-simulado').removeClass('paisagem');
            jQuery('#' + idModal + ' .modelo-simulado').removeClass('retrato');
            jQuery('#' + idModal + ' .modelo-simulado').addClass(data[0].formato);
            jQuery('#' + idModal + ' .margem_superior').val(data[0].marginTop);
            jQuery('#' + idModal + ' .margem_inferior').val(data[0].marginBottom); 
            jQuery('#' + idModal + ' .margem_esquerda').val(data[0].marginLeft);
            jQuery('#' + idModal + ' .margem_direita').val(data[0].marginRight);
            jQuery('#' + idModal + ' .nome').val(data[0].name);
            jQuery('#' + idModal + ' .cor').val(data[0].textColor);
			jQuery('#' + idModal + ' .alinhamento').val(data[0].textAlign);
			jQuery('#' + idModal + ' .fonte').val(data[0].font);
            jQuery('#' + idModal + ' textarea.texto').val(textTextarea);
            jQuery('#' + idModal + ' .modelo-simulado.frente .texto-modelo-simulado .texto').html(text);
            jQuery('#' + idModal + ' .modelo-simulado.frente .texto-modelo-simulado').css({color: data[0].textColor, textAlign: data[0].textAlign});
            jQuery('#' + idModal + ' img.img-modelo').attr('src', data[0].image);
            jQuery('#' + idModal + ' img.simula-validade').hide();
            jQuery('#' + idModal + ' img.simula-validade.' + data[0].formato).show();
			
			if(assinaturaAtiva){				
				var variaveisUsuario = getVariaveisUsuario();
				var textoVariaveis = "";
				textoVariaveis += "Você pode utilizar em seu texto personalizado as variáveis:";
				textoVariaveis += "<br/><strong>Para participantes/alunos</strong>";
				textoVariaveis += "<br/>[NOME_PARTICIPANTE_ALUNO], [EMAIL_PARTICIPANTE_ALUNO],";
				jQuery.each(variaveisUsuario, function(index, arrVar){
					if(arrVar['tipo'] == "personalizada" && arrVar['categoria'] == "aluno"){
						textoVariaveis += " " + arrVar['var'] + ",";
					}
				});
				textoVariaveis += "<br/><strong>Para curso/palestra</strong>";
				textoVariaveis += "<br/>[NOME_PALESTRA_CURSO], [NOME_PALESTRANTE_PROFESSOR], [DATA_PALESTRA_CURSO], [LOCAL_REALIZACAO], [CARGA_HORARIA], [DATA_EMISSAO_CERTIFICADO],";
				jQuery.each(variaveisUsuario, function(index, arrVar){
					if(arrVar['tipo'] == "personalizada" && arrVar['categoria'] == "curso"){
						textoVariaveis += " " + arrVar['var'] + ",";
					}
				});
				textoVariaveis += '<br/><a href="#" onclick="alert(\'Você pode gerenciar suas variáveis apenas acessando o site gerarcertificado.com.br.\');">Gerenciar variáveis</a>';
				jQuery('#myModal-avancado p.variaveis').html(textoVariaveis);
				
				jQuery('#' + idModal + ' .corTextoVerso').val(data[0].verseTextColor);
				jQuery('#' + idModal + ' .corFundoVerso').val(data[0].verseBackgroundColor);				
				jQuery('#' + idModal + ' #btn-remove-img-verso').attr('onclick', 'excluirImagemVersoModelo(' + idCertificado + ')');
				jQuery('#' + idModal + ' .btn-cadastro-modelo-verso').show();
				jQuery('#' + idModal + ' #form-modelo-verso').hide();
				jQuery('#' + idModal + ' #form-modelo-verso input[type="submit"]').attr('onclick', 'criaModeloVerso(' + idCertificado + '); return false;');			
				if(data[0].verseImage == null){
					jQuery('#' + idModal + ' .comImgVerso').hide();
					jQuery('#' + idModal + ' .semImgVerso').show();
					jQuery('#' + idModal + ' img.img-modelo-verso').hide();
				} else {
					jQuery('#' + idModal + ' .comImgVerso').show();
					jQuery('#' + idModal + ' .semImgVerso').hide();
					jQuery('#' + idModal + ' img.img-modelo-verso').attr('src', data[0].verseImage).show();					
				}
				jQuery('#' + idModal + ' textarea.texto_verso').val(textVersoTextarea);
				jQuery('#' + idModal + ' .modelo-simulado.verso .texto-simulado:last-of-type .texto').html(textVerso);				
				alteraFonte();
				alteraCorTextoVerso();
				alteraCorFundoVerso();
			}

            if(data[0].formato == "paisagem"){
                wCertificadoReal = 1811;
                hCertificadoReal = 1299;
            } else if(data[0].formato == "retrato"){
                wCertificadoReal = 1299;
                hCertificadoReal = 1811;
            }
            mSuperiorRealCm = parseFloat(data[0].marginTop);
            mInferiorRealCm = parseFloat(data[0].marginBottom);
            mEsquerdaRealCm = parseFloat(data[0].marginLeft);
            mDireitaRealCm = parseFloat(data[0].marginRight);

            setTimeout(function(){
                calculaPosicaoTexto();
            },1000);
        
            jQuery(window).resize(function(){
                calculaPosicaoTexto();
            });

        }).fail(function() {
            solicitaLogin();
        });
    }
}

function salvarModelo(idCertificado){
	jQuery('#' + idModal).modal('hide');
    if(getToken() && idCertificado != "") {
        var marginTop = jQuery('#' + idModal + ' .margem_superior').val();
        var marginLeft = jQuery('#' + idModal + ' .margem_esquerda').val();
        var marginRight = jQuery('#' + idModal + ' .margem_direita').val();
        var name = jQuery('#' + idModal + ' .nome').val();
        var text = jQuery('#' + idModal + ' textarea.texto').val();
        var textColor = jQuery('#' + idModal + ' .cor').val();
		var textAlign = jQuery('#' + idModal + ' .alinhamento').val();
		var font = jQuery('#' + idModal + ' .fonte').val();
		var verseText = jQuery('#' + idModal + ' textarea.texto_verso').val();
		var verseTextColor = jQuery('#' + idModal + ' .corTextoVerso').val();
		var verseBackgroundColor = jQuery('#' + idModal + ' .corFundoVerso').val();
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/edit/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {idModeloCertificado: idCertificado, margemSuperior: marginTop, margemEsquerda: marginLeft, margemDireita: marginRight, nome: name, texto: text, corTextos: textColor, alinhamentoTextos: textAlign, fonte: font, textoVerso: verseText, corTextosVerso: verseTextColor, corFundoVerso: verseBackgroundColor}            
        }).done(function(data) {
            getModelos('selecionaCertificado(' + idCertificado + ')');
        }).fail(function() {
            solicitaLogin();
        });
    }
}

function alteraFonte(){
	if(jQuery('#' + idModal + ' select[name="fonte"]').length){
		var fonte = jQuery('#' + idModal + ' select[name="fonte"]').val();
		var tamanho = 16;
		if(fonte == "Roboto"){
			weight = 900;
			tamanho = 19;
		} else if(fonte == "Merriweather"){
			weight = 900;  
			tamanho = 18;  
		} else if(fonte == "alexbrush"){
			fonte = "Alex Brush";
			weight = 400;
			tamanho = 26;
		} else if(fonte == "greatvibes"){
			fonte = "Great Vibes";
			weight = 400;
			tamanho = 25;
		} else if(fonte == "pacifico"){
			weight = 400;
			tamanho = 21;
		} else if(fonte == "lobster"){
			weight = 400;
			tamanho = 23;
		}  
		jQuery('.modelo-simulado.frente .texto-modelo-simulado .grande1').css({'font-family': fonte, 'font-size': tamanho + 'px', 'font-weight': weight});
	}
}

function calculaPosicaoTexto(){
    mSuperiorRealPx = (mSuperiorRealCm/10)*pixelEm1Cm;
    mEsquerdaRealPx = (mEsquerdaRealCm/10)*pixelEm1Cm;
    mDireitaRealPx = (mDireitaRealCm/10)*pixelEm1Cm;
    wCertificadoSimulado = jQuery('.modelo-simulado').innerWidth();
    hCertificadoSimulado = jQuery('.modelo-simulado').innerHeight();
    mSuperiorSimulado = (mSuperiorRealPx*hCertificadoSimulado)/hCertificadoReal;
    mEsquerdaSimulado = (mEsquerdaRealPx*wCertificadoSimulado)/wCertificadoReal;
    mDireitaSimulado = (mDireitaRealPx*wCertificadoSimulado)/wCertificadoReal;
    wTextoSimulado = wCertificadoSimulado-mEsquerdaSimulado-mDireitaSimulado;
    jQuery('.modelo-simulado .texto-modelo-simulado').css({opacity: 1, width: wTextoSimulado, top: mSuperiorSimulado, left: mEsquerdaSimulado});
	setTimeout(function(){
		jQuery('#' + idModal + ' .modelo-simulado.verso').css({width: jQuery('#' + idModal + ' .modelo-simulado.frente').innerWidth(), height: jQuery('#' + idModal + ' .modelo-simulado.frente').innerHeight()});
		jQuery('#' + idModal + ' .modelo-simulado.verso .textos-verso').css({display: 'flex'});
	}, 100);
	alteraFonte();
}

function moverTextos(direcao){
    var cmMovimentacao = 0.25;
    if(direcao == "up"){
        mSuperiorRealCm = parseInt(mSuperiorRealCm)-(cmMovimentacao*10);
        mInferiorRealCm = parseInt(mInferiorRealCm)+(cmMovimentacao*10);
        if(mSuperiorRealCm < (cmMovimentacao*10)){
            mSuperiorRealCm = cmMovimentacao*10;
            mInferiorRealCm = parseInt(mInferiorRealCm)-(cmMovimentacao*10);
        }
        jQuery('input[name="margem_superior"]').val(mSuperiorRealCm);
        jQuery('input[name="margem_inferior"]').val(mInferiorRealCm);
    }
    if(direcao == "down"){
        mSuperiorRealCm = parseInt(mSuperiorRealCm)+(cmMovimentacao*10);      
        if(jQuery('.modelo-simulado .texto-modelo-simulado').innerHeight() + mSuperiorSimulado + 40 >= hCertificadoSimulado){
            mSuperiorRealCm = parseInt(mSuperiorRealCm)-(cmMovimentacao*10);
        }
        jQuery('input[name="margem_superior"]').val(mSuperiorRealCm);
    }
    if(direcao == "left"){
        mEsquerdaRealCm = parseInt(mEsquerdaRealCm)-(cmMovimentacao*10);
        mDireitaRealCm = parseInt(mDireitaRealCm)+(cmMovimentacao*10);
        if(mEsquerdaRealCm < (cmMovimentacao*10)){
            mEsquerdaRealCm = cmMovimentacao*10;
            mDireitaRealCm = parseInt(mDireitaRealCm)-(cmMovimentacao*10);
        }
        jQuery('input[name="margem_esquerda"]').val(mEsquerdaRealCm);
        jQuery('input[name="margem_direita"]').val(mDireitaRealCm);
    }
    if(direcao == "right"){
        mDireitaRealCm = parseInt(mDireitaRealCm)-(cmMovimentacao*10);
        mEsquerdaRealCm = parseInt(mEsquerdaRealCm)+(cmMovimentacao*10);            
        if(mDireitaRealCm < (cmMovimentacao*10)){
            mDireitaRealCm = cmMovimentacao*10;
            mEsquerdaRealCm = parseInt(mEsquerdaRealCm)-(cmMovimentacao*10);
        }
        jQuery('input[name="margem_direita"]').val(mDireitaRealCm);
        jQuery('input[name="margem_esquerda"]').val(mEsquerdaRealCm);            
    }
    calculaPosicaoTexto();
}

function alteraCorTexto(){
    var novaCor = jQuery('input#cor').val();
    jQuery('.modelo-simulado .texto-modelo-simulado').css({color: novaCor});
}

function alteraAlinhamentoTexto(){
    var novoAlinhamento = jQuery('select#alinhamento').val();
    jQuery('.modelo-simulado .texto-modelo-simulado').css({textAlign: novoAlinhamento});
}

function alteraCorTextoVerso(){
	var novaCor = jQuery('#' + idModal + ' input.corTextoVerso').val();
	jQuery('.modelo-simulado.verso .texto-simulado').css({color: novaCor});
}

function alteraCorFundoVerso(){
	var novaCor = jQuery('#' + idModal + ' input.corFundoVerso').val();
	jQuery('#' + idModal + ' .modelo-simulado.verso').css({backgroundColor: novaCor});
	jQuery('#' + idModal + ' .modelo-simulado.verso .texto-simulado.programa').css({borderColor: novaCor});
}

function alteraTexto(){
	var variaveisUsuario = getVariaveisUsuario();
    var novoTexto = jQuery('textarea.texto').val();
    novoTexto = novoTexto.replace(/(?:\ r\n|\r|\n)/g, '<br/>');
    novoTexto = novoTexto.replace(/\[NOME_PARTICIPANTE_ALUNO\]/g, '<span class="grande1">Nome do aluno</span>');
    novoTexto = novoTexto.replace(/\[NOME_PALESTRA_CURSO\]/g, '<span class="grande2">título da palestra ou curso</span>');
    novoTexto = novoTexto.replace(/\[NOME_PALESTRANTE_PROFESSOR\]/g, '<span class="grande2">Nome do instrutor</span>');
    novoTexto = novoTexto.replace(/\[DATA_PALESTRA_CURSO\]/g, '<span>Agosto/2020</span>');
    novoTexto = novoTexto.replace(/\[LOCAL_REALIZACAO\]/g, '<span>São José/SC</span>');
    novoTexto = novoTexto.replace(/\[CARGA_HORARIA\]/g, '<span>300 horas</span>');
	novoTexto = novoTexto.replace(/\[DATA_EMISSAO_CERTIFICADO\]/g, '<span>14/08/2020</span>');
	jQuery.each(variaveisUsuario, function(index, arrVar){
		if(arrVar['tipo'] == "personalizada"){
			var str = "\\" + arrVar['var'].replace("\]", "\\]");
			var regex = new RegExp(str, "g");
			novoTexto = novoTexto.replace(regex, '<span>' + arrVar['label'] + '</span>');
		}
	});
    jQuery('#' + idModal + ' .modelo-simulado .texto-modelo-simulado .texto').html(novoTexto);
    calculaPosicaoTexto();
}

function alteraTextoVerso(){
	var variaveisUsuario = getVariaveisUsuario();
	var novoTexto = jQuery('#' + idModal + ' textarea.texto_verso').val();
	//verifica se existe pelo menos a variável do nome do aluno
	jQuery('#form-modelo p.erro-variaveis.verso').hide();
	novoTexto = novoTexto.replace(/(?:\ r\n|\r|\n)/g, '<br/>');
	novoTexto = novoTexto.replace(/\[NOME_PARTICIPANTE_ALUNO\]/g, 'Nome Completo do Aluno');
	novoTexto = novoTexto.replace(/\[NOME_PALESTRA_CURSO\]/g, 'título da palestra ou curso');
	novoTexto = novoTexto.replace(/\[NOME_PALESTRANTE_PROFESSOR\]/g, 'Nome do instrutor');
	novoTexto = novoTexto.replace(/\[DATA_PALESTRA_CURSO\]/g, 'Agosto/2020');
	novoTexto = novoTexto.replace(/\[LOCAL_REALIZACAO\]/g, 'São José/SC');
	novoTexto = novoTexto.replace(/\[CARGA_HORARIA\]/g, '300 horas');
	novoTexto = novoTexto.replace(/\[DATA_EMISSAO_CERTIFICADO\]/g, '<span>14/08/2020</span>');
	jQuery.each(variaveisUsuario, function(index, arrVar){
		if(arrVar['tipo'] == "personalizada"){
			var str = "\\" + arrVar['var'].replace("\]", "\\]");
			var regex = new RegExp(str, "g");
			novoTexto = novoTexto.replace(regex, '<span>' + arrVar['label'] + '</span>');
		}
	});
	jQuery('#' + idModal + ' .modelo-simulado.verso .texto-simulado:last-of-type .texto').html(novoTexto);
}

jQuery('#input-form-modelo-verso').on('change', function(){
    const file = jQuery(this)[0].files[0];
    const fileReader = new FileReader();
    fileReader.onloadend = function(){        
        //se tiver mais de 250kb
        if(file.size > 250000){
            alert('arquivo muito grande')
        }
        //se não for jpg
        if(file.type != "image/jpeg") {
            alert('arquivo precisa estar no formato JPG')
        }
        //ativa envio ou não
        if(file.size > 250000 || file.type != "image/jpeg"){
            jQuery('#form-modelo-verso input[type="submit"]').attr('disabled','disabled');
            b64ModeloVerso = "";
        } else {
            jQuery('#form-modelo-verso input[type="submit"]').removeAttr('disabled');
            b64ModeloVerso = fileReader.result;
        }            
    }
    fileReader.readAsDataURL(file);
});

function informarCadastroModeloVerso(){
    jQuery('#' + idModal + ' .btn-cadastro-modelo-verso').hide();
    jQuery('#' + idModal + ' #form-modelo-verso').show();
}

function criaModeloVerso(idModelo){
    if(getToken() && idModelo > 0 && b64ModeloVerso != "" && confirm('As possiveis alterações serão salvas no modelo para que a imagem do verso seja enviada. Confirma?')) {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/editBackgoundImage/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {idModeloCertificado: idModelo, acao: "Add", b64: b64ModeloVerso}            
        }).done(function(data) {
            salvarModelo(idModelo);
			setTimeout(function(){
				editarModelo(idModelo);
			}, 1000);
        }).fail(function() {
            solicitaLogin();
        });
    }
}

function excluirImagemVersoModelo(idModelo){	
    if(getToken() && idModelo > 0 && confirm('As possiveis alterações serão salvas no modelo para que a imagem do verso seja removida. Confirma?')) {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/editBackgoundImage/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {idModeloCertificado: idModelo, acao: 'Del'}            
        }).done(function(data) {
            salvarModelo(idModelo);
			setTimeout(function(){
				editarModelo(idModelo);
			}, 1000);
        }).fail(function() {
            solicitaLogin();
        });
    }
}

function excluirModelo(idModelo){
    if(getToken() && idModelo > 0 && confirm('Deseja mesmo excluir este modelo?')) {
        jQuery.ajax({
            type: "POST",
            url: urlBaseApi + "models/delete/V1/",
            dataType: 'json',
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + getToken());
            },
            data: {idModel: idModelo}            
        }).done(function(data) {
            idModeloSelecionado = 0;
            getModelos();
        }).fail(function() {
            solicitaLogin();
        });
    }
}

function selecionaPasso(passo){
    if(passo > 0){
        jQuery('.nav-abas .nav-aba').removeClass('current');
        jQuery('.abas .aba').removeClass('current');
        jQuery('.acoes .btn').removeClass('atencao');
        jQuery('.nav-abas #nav-aba-' + passo).addClass('current');
        jQuery('.abas #aba-' + passo).addClass('current');
        passosCompletos();
		if(passo == 3){
			if(localStorage.getItem('pgc-verso') == "1"){
				jQuery('p#verso-desabilitado').hide();
				jQuery('#form-manual-programacao').show();
			}
        } else if(passo == 4){
            contaCreditosAUtilizar();
        }
        jQuery('#preview a.btn-preview').removeClass('atencao');
        setTimeout(function(){
            jQuery('#preview a.btn-preview').addClass('atencao');
        }, 2000);
    }
}

function passosCompletos(){   
    if(idModeloSelecionado > 0){
        jQuery('.nav-abas #nav-aba-1').addClass('ok');
        jQuery('.nav-abas #nav-aba-2').addClass('habilitado').attr('onclick','selecionaPasso(2)');
        jQuery('.acoes .btn-to-2').removeClass('desabilitado').addClass('atencao').attr('onclick','selecionaPasso(2)');;                
    } else {
        jQuery('.nav-abas #nav-aba-1').removeClass('ok');
        jQuery('.nav-abas #nav-aba-2').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.nav-abas #nav-aba-3').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.nav-abas #nav-aba-4').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.acoes .btn-to-2').addClass('desabilitado').removeClass('atencao').removeAttr('onclick');
    }
    if(idModeloSelecionado > 0 && qtdAlunos > 0){
        jQuery('.nav-abas #nav-aba-2').addClass('ok');
        jQuery('.nav-abas #nav-aba-3').addClass('habilitado').attr('onclick','selecionaPasso(3)');
        jQuery('.acoes .btn-to-3').removeClass('desabilitado').addClass('atencao').attr('onclick','selecionaPasso(3)');;
    } else {
        jQuery('.nav-abas #nav-aba-2').removeClass('ok');
        jQuery('.nav-abas #nav-aba-3').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.nav-abas #nav-aba-4').removeClass('ok').removeClass('habilitado').removeAttr('onclick');
        jQuery('.acoes .btn-to-3').addClass('desabilitado').removeClass('atencao').removeAttr('onclick');
    }
    if(idModeloSelecionado > 0 && qtdAlunos > 0 && dadosCursoValidados == true){
        jQuery('.nav-abas #nav-aba-3').addClass('ok'); 
        jQuery('.nav-abas #nav-aba-4').addClass('habilitado').attr('onclick','selecionaPasso(4)');
        jQuery('.aplicacao .abas .aba .acoes #btn-passo-final').removeClass('desabilitado').attr('onclick','selecionaPasso(4)');
        jQuery('.acoes .btn-to-4').addClass('atencao');
    } else {
        jQuery('.nav-abas #nav-aba-3').removeClass('ok');
        jQuery('.nav-abas #nav-aba-4').removeClass('habilitado').removeAttr('onclick');
        jQuery('.aplicacao .abas .aba .acoes #btn-passo-final').addClass('desabilitado').removeAttr('onclick');
        jQuery('.acoes .btn-to-4').removeClass('atencao');
    }
}

function selecionaCertificado(idCertificado){
    if(idCertificado > 0){
        jQuery('.acoes .btn-to-2').removeClass('atencao');
        jQuery('.certificados .certificado').removeClass('selecionado');
        jQuery('.certificados #certificado-' + idCertificado).addClass('selecionado');
        idModeloSelecionado = idCertificado;
        jQuery('html, body').animate({ 
            scrollTop: jQuery('html').height()
        }, 500, function(){
            passosCompletos();
        });
        jQuery('#preview a.btn-preview').removeAttr('disabled').addClass('atencao');
    }
}

function verificaQtdAlunos(){
    qtdAlunos = alunos.length;
    passosCompletos();
}

function botoesCadastroManual(){
    if(jQuery('#form-manual-aluno .dados').length == 1){
        jQuery('#form-manual-aluno .dados:first-of-type button.remove').hide();
        jQuery('#form-manual-aluno .dados:first-of-type button.add').show();
    } else {
        jQuery('#form-manual-aluno .dados button.remove').show();
        jQuery('#form-manual-aluno .dados button.add').hide();
        jQuery('#form-manual-aluno .dados:last-of-type button.add').show();
    }
}

function addLinhaCadastroManual(withFocus = true){
    if(!withFocus){
        if(jQuery('#form-manual-aluno .dados:last-of-type input[name="nome"]').val() == "" && jQuery('#form-manual-aluno .dados:last-of-type input[name="email"]').val() == ""){
            return false;
        }
    }
    jQuery('#form-manual-aluno .dados:last-of-type').clone().appendTo('#form-manual-aluno #dados').find('input').val('');
    if(withFocus) {
        jQuery('#form-manual-aluno .dados:last-of-type input[type=text]:first-of-type').focus();
    }
    botoesCadastroManual();
}

function removeLinhaCadastroManual(elm){
    jQuery(elm).parent().parent().remove();
    atualizarAlunosManualmente();
    botoesCadastroManual();
}

function atualizarAlunosManualmente(){
    alunos = [];
    var dados = jQuery('#form-manual-aluno').serialize().split('nome=');
    jQuery.each(dados, function(index, value){
		value = decodeURIComponent(value);
        var arrValue = value.split('&');        
        if(arrValue[0] != ""){
            var nome = arrValue[0].replace("nome=", "");
            var mail = arrValue[1].replace("email=", "");
			arrValue.splice(0 ,2);
			var variaveisCustomizadasAluno = [];			
			jQuery.each(arrValue, function(index, valueCustom){
				var dadosCustomizados = valueCustom.split("&");
				jQuery.each(dadosCustomizados, function(index, dadoCustomizado){
					var dadoCustom = dadoCustomizado.split("=");
					variaveisCustomizadasAluno.push(dadoCustom[1]);
				});
			});
            alunos.push({'nome': nome, 'email': mail, 'variaveisCustomizadasAluno': variaveisCustomizadasAluno.join(";"), 'certificado': false, 'enviar': 'Não'});     
        }   
    });	
    verificaQtdAlunos();
    //atualiza passos 3 e 4
    verificaDadosCurso();    
    populaAlunosTabelaFinal();
    populaAlunosTabelaSucesso();
    contaCreditosAUtilizar();
}

function botoesCadastroManualProgramacao(){
    if(jQuery('#form-manual-programacao .dados').length == 1){
        jQuery('#form-manual-programacao .dados:first-of-type button.remove').hide();
        jQuery('#form-manual-programacao .dados:first-of-type button.add').show();
    } else {
        jQuery('#form-manual-programacao .dados button.remove').show();
        jQuery('#form-manual-programacao .dados button.add').hide();
        jQuery('#form-manual-programacao .dados:last-of-type button.add').show();
    }
}

function addLinhaCadastroManualProgramacao(withFocus = true){
    if(!withFocus){
        if(jQuery('#form-manual-programacao .dados:last-of-type input[name="texto"]').val() == ""){
            return false;
        }
    }
    jQuery('#form-manual-programacao .dados:last-of-type').clone().appendTo('#form-manual-programacao #dados').find('input').val('');
    if(withFocus) {
        jQuery('#form-manual-programacao .dados:last-of-type input[type=text]').focus();
    }
    botoesCadastroManualProgramacao();
}

function removeLinhaCadastroManualProgramacao(elm){
    jQuery(elm).parent().parent().remove();
    atualizarAlunosManualmente();
    botoesCadastroManualProgramacao();
	verificaDadosCurso();
}

function atualizarProgramacaoManualmente(){
    programas = [];
    var dados = jQuery('#form-manual-programacao').serialize().split('texto=');
    jQuery.each(dados, function(index, value){
        if(value != ""){
            var nome = decodeURIComponent(value);
			nome = nome.replace(/&/g, "");
            nome = nome.replace(/\+/g, " ");
            nome = nome.replace(/%20/g, " ");
            programas.push(nome);   
        }   
    });
	verificaDadosCurso();
}

function verificaDadosCurso(){
    palestraTitulo = jQuery('#form-dados-curso #curso').val();
    palestraProfessor = jQuery('#form-dados-curso #palestrante').val();
    palestraData = jQuery('#form-dados-curso #data').val();
    palestraLocal = jQuery('#form-dados-curso #local').val();
    palestraCargaHoraria = jQuery('#form-dados-curso #carga-horaria').val();
	var variaveisUsuario = getVariaveisUsuario();
	dadosCustomizadosPalestra = new Array();
	jQuery.each(variaveisUsuario, function(index, arrVar){
		if(arrVar['tipo'] == "personalizada" && arrVar['categoria'] == "curso"){
			var valorCampoCustomizado = jQuery('#form-dados-curso input[name="' + arrVar['var'] + '"]').val();
			dadosCustomizadosPalestra.push(valorCampoCustomizado);
		}
	});
    if(palestraTitulo != "" && palestraData != "" && palestraCargaHoraria != "" && programas.length <= 28){
        dadosCursoValidados = true;
        palestraTitulo = palestraTitulo.replaceAll("\"","'");
        palestraProfessor = palestraProfessor.replaceAll("\"","'");
        palestraData = palestraData.replaceAll("\"","'");
        palestraLocal = palestraLocal.replaceAll("\"","'");
        palestraCargaHoraria = palestraCargaHoraria.replaceAll("\"","'");	
		jQuery.each(dadosCustomizadosPalestra, function(index, dado){
			dadosCustomizadosPalestra[index] = dado.replaceAll("\"","'");
		});
		jQuery('#form-verso #alert-muitos-programas').hide();
    } else {
        dadosCursoValidados = false;
		if(programas.length > 28){
			jQuery('#form-verso #alert-muitos-programas').show();
		}
    }
    passosCompletos();
}

function populaAlunosTabelaFinal(){
    jQuery('#rodar-algoritmo table tbody tr.aluno').remove();
    var alunosInvertido = alunos.slice(0).reverse();
    jQuerynumAluno = alunosInvertido.length;
    jQuery.each(alunosInvertido, function(index, arrAluno){
        var elem = '<tr class="aluno">';

        elem += '<td>#' + jQuerynumAluno + '</td>';

        elem += '<td>';
        elem += arrAluno.nome;
        elem += '<div class="status">';
        elem += '<div class="texto">';
        elem += '<strong>Status: </strong>'
        if(!arrAluno.certificado) {
            elem += 'Aguardando';
        } else {
            elem += 'Certificado gerado';
        }    
        elem += '</div>';
        elem += '<div class="progress">';
        elem += '<div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100"></div>';
        elem += '</div>';
        elem += '</div>';
        elem += '<div class="gerar">';               
        if(jQuerynumAluno == 1) {     
            elem += '<button class="btn btn-sm btn-primary" onclick="gerarCertificadoAvulso(' + jQuerynumAluno + ')">';
            elem += '<span class="dashicons dashicons-awards"></span>Gerar teste';
            elem += '</button>'; 
        }
        elem += '</div>';
        elem += '</td>';

        elem += '<td>';
        var reg = /^\w+([-+.\']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
        if(arrAluno.email == "") {
            elem += '<input type="checkbox" disabled="disabled"> E-mail não informado';
        } else if(!reg.test(arrAluno.email)) {
            elem += '<input type="checkbox" disabled="disabled"> ';
            elem += arrAluno.email;
            elem += ' <span class="label label-danger">inválido</span>';
        } else {
            elem += '<input type="checkbox" class="emailEnvio" checked="checked" onclick="contaCreditosAUtilizar();" value="' + jQuerynumAluno + '"> ';
            elem += arrAluno.email;
        }                
        elem += '</td>';

        elem += '</tr>';
        jQuery(elem).prependTo('#rodar-algoritmo table tbody');
        jQuerynumAluno = jQuerynumAluno-1;
    });
}

function populaAlunosTabelaSucesso(){
    jQuery('#sucesso table tbody tr.aluno').remove();
    var alunosInvertido = alunos.slice(0).reverse();
    jQuerynumAluno = alunosInvertido.length;
    jQuery.each(alunosInvertido, function(index, arrAluno){
        var elem = '<tr class="aluno">';
        elem += '<td>#' + jQuerynumAluno + '</td>';
        elem += '<td>' + arrAluno.nome + '</td>';
        elem += '<td class="cert"></td>';
        elem += '</tr>';
        jQuery(elem).prependTo('#sucesso table tbody');
        jQuerynumAluno = jQuerynumAluno-1;
    });
}

function selectEnviarTodosCertificados(elm){
    if(jQuery(elm).is(":checked")){
        jQuery('input.emailEnvio').prop('checked', true);
    } else {
        jQuery('input.emailEnvio').prop('checked', false);
    }
    contaCreditosAUtilizar();
}

function selectEnviarCertificado(elm){
    contaCreditosAUtilizar();
}

function contaCreditosAUtilizar(){
    var numCreditosEmissao = qtdAlunos;
    var numCreditosEnvio = 0
    var numCreditos = 0
    jQuery('input.emailEnvio').each(function(){
        if(jQuery(this).is(":checked")){
            alunos[jQuery(this).val()-1].enviar = "Sim";
            numCreditosEnvio++;
        } else {
            alunos[jQuery(this).val()-1].enviar = "Não";
        }        
    });
    numCreditos = numCreditosEmissao + numCreditosEnvio;
    if(numCreditos > 0 && numCreditos > saldoAssinaturaUsuario){
		if(numCreditosEmissao-saldoAssinaturaUsuario > 0) {
            jQuery('p#qtdCreditosAUtilizar-emissao').show();
            jQuery('p#qtdCreditosAUtilizar-emissao span').html(numCreditosEmissao-saldoAssinaturaUsuario);
        } else {
            jQuery('p#qtdCreditosAUtilizar-emissao').hide();
        }
		if(numCreditosEnvio-saldoAssinaturaUsuario > 0){            
            jQuery('p#qtdCreditosAUtilizar-envio').show();
            jQuery('p#qtdCreditosAUtilizar-envio span').html(numCreditosEnvio-saldoAssinaturaUsuario);
        } else {
            jQuery('p#qtdCreditosAUtilizar-envio').hide();
            jQuery('input#enviarTodos').prop('checked', false);            
        }
		if((numCreditosEmissao-saldoAssinaturaUsuario > 0) || numCreditosEnvio-saldoAssinaturaUsuario > 0){
			jQuery('.aplicacao #rodar-algoritmo table tr.creditos').show();
		} else {
			jQuery('.aplicacao #rodar-algoritmo table tr.creditos').hide();
		}
    } else {
        jQuery('.aplicacao #rodar-algoritmo table tr.creditos').hide();
    }
	if(jQuery('.aplicacao #rodar-algoritmo table tr.alerta.franquia').length) {
		if(numCreditos > saldoAssinaturaUsuario && saldoAssinaturaUsuario > 0){
			jQuery('.aplicacao #rodar-algoritmo table tr.alerta.franquia').show();
			jQuery('.aplicacao #rodar-algoritmo table tr.alerta.franquia p:first-of-type').show();
			jQuery('.aplicacao #rodar-algoritmo table tr.alerta.franquia p:last-of-type').hide();
		} else if(saldoAssinaturaUsuario == 0){
			jQuery('.aplicacao #rodar-algoritmo table tr.alerta.franquia').show();
			jQuery('.aplicacao #rodar-algoritmo table tr.alerta.franquia p:first-of-type').hide();
			jQuery('.aplicacao #rodar-algoritmo table tr.alerta.franquia p:last-of-type').show();
		}
	}
	if(numCreditos > parseInt(saldoAssinaturaUsuario)+parseInt(saldoUsuario)){		
        jQuery('.aplicacao #rodar-algoritmo table tr.alerta.avulso').show();
        jQuery('p#faltaCreditos span').html(saldoUsuario);
        jQuery('.aplicacao .abas .aba .acoes #btn-gerar-todos').addClass('desabilitado').removeAttr('onclick');        
    } else {
        jQuery('.aplicacao #rodar-algoritmo table tr.alerta.avulso').hide();
        jQuery('.aplicacao .abas .aba .acoes #btn-gerar-todos').removeClass('desabilitado').attr('onclick','iniciarGerarEmLote()');
    }
}

function gerarCertificadoAvulso(numNaLista){
    //valida infos
    if(idModeloSelecionado == 0){
        alert('Antes de gerar certificados, você precisa definir um modelo (passo 1)');
        return false;
    } else if(qtdAlunos == 0){
        alert('Antes de gerar certificados, você precisa definir a lista de alunos (passo 2)');
        return false;
    } else if(!dadosCursoValidados){
        alert('Antes de gerar certificados, você precisa informar os dados do curso (passo 3)');
        return false;
    } else if(saldoUsuario == 0 && tcert == 'validado'){
        alert('Infelizmente seu saldo de créditos chegou a zero. Você precisa adquirir mais créditos para emitir certificados via plugin');
        return false;
    }
    if(gerando == false) {
        gerando = true;
        jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .texto').hide();
        jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .progress').css('display', 'flex');
        setTimeout(function(){
            jQuery('#rodar-algoritmo .progress-bar.active').css({width: '50%'});
        }, 100);
        setTimeout(function(){
            jQuery('#rodar-algoritmo .progress-bar.active').css({width: '100%'});
        }, 1000);
        setTimeout(function(){     
            var url = urlBaseApi + "create/test/V1/";
            var data = { idModeloCertificado: idModeloSelecionado, nome: alunos[numNaLista-1].nome, variaveisCustomizadasAluno: alunos[numNaLista-1].variaveisCustomizadasAluno, titulo: palestraTitulo, professor: palestraProfessor, data: palestraData, local: palestraLocal, cargaHoraria: palestraCargaHoraria, variaveisCustomizadasCurso: dadosCustomizadosPalestra.join(";"), programa: programas.join(";") };
            if(tcert == 'validado'){
                url = urlBaseApi + "create/valid/V1/";
                data = { idModeloCertificado: idModeloSelecionado, nome: alunos[numNaLista-1].nome, email: alunos[numNaLista-1].email, variaveisCustomizadasAluno: alunos[numNaLista-1].variaveisCustomizadasAluno, enviar: alunos[numNaLista-1].enviar, titulo: palestraTitulo, professor: palestraProfessor, data: palestraData, local: palestraLocal, cargaHoraria: palestraCargaHoraria, variaveisCustomizadasCurso: dadosCustomizadosPalestra.join(";"), programa: programas.join(";") };
            }
                 
            jQuery.ajax({
                type: "POST",
                url: url,
                beforeSend: function (xhr) {
                    xhr.setRequestHeader("Authorization", "Basic " + getToken());
                },
                data: data,
            }).done(function(data) {
                var b64 = data.fileBase64;
                b64 = b64.replace('data:application/pdf;base64,','');
                alunos[numNaLista-1].certificado = b64;
                jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .texto').html('<strong>Status: </strong><a id="link-download-teste" download="certificado (' + alunos[numNaLista-1].nome + ').pdf" href="data:application/octet-stream;base64,' + b64 +'">Certificado gerado</a>').show();
                jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .progress').hide();
                jQuery('#rodar-algoritmo .progress-bar.active').css({width: '0'});
                jQuery('#sucesso table tr:nth-child(' + numNaLista + ') .cert').html('<a id="link-download-teste" download="certificado (' + alunos[numNaLista-1].nome + ').pdf" href="data:application/octet-stream;base64,' + b64 +'">Download certificado (' + alunos[numNaLista-1].nome + ').pdf</a>').show();
                contaCreditosAUtilizar();
                gerando = false;
                if(gerandoLote){
                    jQuery('.aplicacao #rodar-algoritmo table tr.creditos, .aplicacao #rodar-algoritmo table tr.alerta').hide();
                    jQuery('input#enviarTodos').remove();
                    jQuery('input[type="checkbox"]').prop('disabled', true);
                    gerarTodosCertificados(numNaLista+1);
                    getSaldoUsuario();
                } else {
                    jQuery('#link-download-teste')[0].click();
                }
            }).fail(function() {
                solicitaLogin();
            });
        }, 1000);
    }
}

function iniciarGerarEmLote(){
    if(jQuery('#ciencia-1').is(":checked") && jQuery('#ciencia-2').is(":checked")){
        gerandoLote = true;
        tcert = 'validado';
        jQuery('.title-abas').remove();
        jQuery('.nav-abas').remove();
        jQuery('.aplicacao .abas .aba .acoes').remove();
        jQuery('.aplicacao #rodar-algoritmo table tr.creditos, .aplicacao #rodar-algoritmo table tr.alerta').hide();
        jQuery('input#enviarTodos').remove();
        jQuery('input[type="checkbox"]').prop('disabled', true);       
        gerarTodosCertificados(1);
    } else {
        alert('Para iniciar a emissão você precisa informar que está ciente dos itens informados acima.');
    }
}

function gerarTodosCertificados(numNaLista){
    if(gerandoLote) {
        jQuery('.aplicacao table .gerar').remove();
        if(jQuery('#rodar-algoritmo table tr:nth-child(' + numNaLista + ') .status .texto').length){
            gerarCertificadoAvulso(numNaLista);
        } else {
            gerandoLote = false;
            selecionaPasso(5);
        }
    }
}